//----------------------------------------------------------------------------------
//		WvEBhE XN[Ή Wrapper
//----------------------------------------------------------------------------------
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "filter.h"
//#define DEBUG
//#include "dbgtrace.h"

// cl /LD /O1 jump_mhw.cpp jump_mhw.def /Fejump_mhw.auf
#pragma comment(linker, "/opt:nowin98 /merge:.rdata=.text")
#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "user32.lib")


#ifndef lengthof
#define lengthof(arr)	(sizeof(arr) / sizeof((arr)[0]))
#endif

#ifndef WM_MOUSEHWHEEL
#define WM_MOUSEHWHEEL			0x020E
#endif

#ifndef GET_WHEEL_DELTA_WPARAM
#define GET_WHEEL_DELTA_WPARAM(wParam)	((short)HIWORD(wParam))
#endif

typedef FILTER_DLL * (__stdcall *pfGetFilterTable)(void);

BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam,
		void *editp, FILTER *fp);

HMODULE hModule;
BOOL (*pfunc_WndProc)(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam,
		void *editp, FILTER *fp);


#if 1
//---------------------------------------------------------------------
//		DllMain
//---------------------------------------------------------------------
extern "C" BOOL WINAPI _DllMainCRTStartup(HANDLE hDllHandle, DWORD dwReason, LPVOID lpreserved)
{
	return TRUE;
}
#endif

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
	FILTER_FLAG_DISP_FILTER | FILTER_FLAG_EX_INFORMATION,
	0, 0,
	"WvEBhE",
	0, NULL, NULL,
	NULL, NULL,
	0, NULL, NULL,
	NULL,
	/*func_init*/ NULL,
	/*func_exit*/ NULL,
	NULL,
	/*func_WndProc*/ NULL,
	NULL, NULL,
	NULL,
	NULL,
	"WvEBhE XN[Ή Wrapper version 0.01 by K.Takata",
	NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL,
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
	hModule = LoadLibrary("jump.dll");
	if (hModule == NULL) {
		hModule = LoadLibrary("Plugins\\jump.dll");
	}
	if (hModule == NULL) {
		MessageBox(NULL ,"WvEBhE (jump.dll) ܂",
				"WvEBhE XN[Ή Wrapper",
				MB_ICONINFORMATION);
		return &filter;
	}
	pfGetFilterTable pGetFilterTable = (pfGetFilterTable)
			GetProcAddress(hModule, "GetFilterTable");
	if (pGetFilterTable == NULL) {
		return &filter;
	}
	
	hModule = GetModuleHandle("jump.dll");
	FILTER_DLL *filter_jump = pGetFilterTable();
	filter = *filter_jump;
	pfunc_WndProc = filter.func_WndProc;
	filter.func_WndProc = func_WndProc;
	return &filter;
}


//---------------------------------------------------------------------
//		
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	return TRUE;
}


//---------------------------------------------------------------------
//		I
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
	return TRUE;
}


//---------------------------------------------------------------------
//		WndProc
//---------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam,
		void *editp, FILTER *fp)
{
	int zDelta;
	
	fp->dll_hinst = hModule;
	
	switch (message) {
	case WM_MOUSEHWHEEL:
		zDelta = GET_WHEEL_DELTA_WPARAM(wParam);
		if (zDelta > 0) {
			pfunc_WndProc(hwnd, WM_HSCROLL, SB_PAGERIGHT, 0, editp, fp);
			return pfunc_WndProc(hwnd, WM_HSCROLL, SB_ENDSCROLL, 0, editp, fp);
		} else if (zDelta < 0) {
			pfunc_WndProc(hwnd, WM_HSCROLL, SB_PAGELEFT, 0, editp, fp);
			return pfunc_WndProc(hwnd, WM_HSCROLL, SB_ENDSCROLL, 0, editp, fp);
		}
		break;
		
	default:
		return pfunc_WndProc(hwnd, message, wParam, lParam, editp, fp);
	}
	return FALSE;
}
